openkey = 0x69 -- You can change the Keycode (0x69 = NUM9), lookup the codes here: https://msdn.microsoft.com/de-de/library/windows/desktop/dd375731%28v=vs.85%29.aspx
downKey = 0x62
upKey = 0x68
selectKey = 0x65
backKey = 0x60
--Below you can add/edit colors in the given way. The numbers are the rgb values.
	color = {}
	color.random = {0, 0, 0}
	color.black = {0, 0, 0}
	color.white = {255, 255, 255}
	color.red = {255,0,0}
	color.lime = {0,255,0}
	color.blue = {0,0,255}
	color.yellow = {255,255,0}
	color.gray = {128,128,128}
	color.orange = {255,165,0}
	color.DeepPink = {255,20,147}
	color.chocolate = {210,105,30}
--##################################################################################
--######DONT##EDIT##BELOW#!!!########IF##YOU##DONT##KNOW##WHAT##YOURE##DOING########
--##################################################################################
main = ScriptThread("ricks_instant_customs")	
function GUIinit()
	GUI = {}
	GUI.menu = {}
	GUI.buttons = {}
	GUI.navButtons = 	{
					["menuOpen"] = 
					{
						["keys"] = {},
						["menu"] = ""
					}, 
					["menuPrev"] = {["keys"] = {}},
					["navUp"] = {["keys"] = {}},
					["navDown"] = {["keys"] = {}},
					["select"] = {["keys"] = {}},
					["navBack"] = {["keys"] = {}}
				}
	GUI.activeButton = 1
	GUI.activeMenu = ""
	GUI.statusText = {["text"] = "", ["time"] = 0}

	function GUI.createMenu(menuName, prevMenu, title, xpos, ypos, xscale, yscale, buttonSpacing, textScale, font)
		if(GUI.menu[menuName] == nil) then
			GUI.menu[menuName] = {}
			lastOffset = ypos + yscale + buttonSpacing
		end

		GUI.menu[menuName] = {
			["prevMenu"] = prevMenu,
			["title"] = title,
			["xpos"] = xpos,
			["ypos"] = ypos,
			["xscale"] = xscale,
			["yscale"] = yscale,
			["spacing"] = buttonSpacing,
			["lastOffset"] = lastOffset,
			["numButtons"] = 0,
			["textScale"] = textScale,
			["font"] = font
		}
	end
	
	function GUI.addButton(parentMenu, text, funct, args, toggleable, textScale, font)
		if(GUI.buttons[parentMenu] == nil or GUI.buttons[parentMenu]["settings"] == nil) then
			GUI.buttons[parentMenu] = {["settings"] = {}}
		end

		local currButtonNum = #GUI.buttons[parentMenu].settings + 1
		GUI.menu[parentMenu].numButtons = currButtonNum

		if(toggleable) then
			toggledOn = false
		else
		    toggledOn = nil
		end

		GUI.buttons[parentMenu].settings[currButtonNum] = {
			["parentMenu"] = parentMenu,
			["text"] = text,
			["funct"] = funct,
			["args"] = args,
			["font"] = font,
			["xpos"] = GUI.menu[parentMenu].xpos,
			["ypos"] = GUI.menu[parentMenu].lastOffset,
			["xscale"] = GUI.menu[parentMenu].xscale,
			["yscale"] = GUI.menu[parentMenu].yscale,
			["textScale"] = textScale,
			["toggleable"] = toggleable,
			["toggledOn"] = toggledOn
		}

		GUI.menu[parentMenu]["lastOffset"] = (GUI.menu[parentMenu].lastOffset + GUI.menu[parentMenu].yscale + GUI.menu[parentMenu].spacing)
	end

	function GUI.setActiveMenu(menuName)
		GUI.activeButton = 1
		GUI.activeMenu = menuName
	end

	function GUI.updateStatusText(text, time)
		GUI.statusText = {["text"] = text, ["time"] = time}
	end

	function GUI.isButtonToggledOn()
		local activeButton = GUI.buttons[GUI.activeMenu].settings[GUI.activeButton]
		if(activeButton.toggleable) then
			return activeButton.toggledOn
		elseif(activeButton.toggleable == flse) then
			print("Button \"", GUI.buttons[GUI.activeMenu].settings[GUI.activeButton].text, "\" isn't toggleable!")
		    return nil
		end
	end

	function GUI.toggleButtonState()
		local activeButton = GUI.buttons[GUI.activeMenu].settings[GUI.activeButton]
		
		if(GUI.isButtonToggledOn() and activeButton.toggleable) then
			activeButton.toggledOn = false
		elseif(GUI.isButtonToggledOn() == false and activeButton.toggleable) then
			activeButton.toggledOn = true
			print("toggled on")
		end
	end

	--todo
	function GUI.removeButton()
	end
	
	--todo
	function GUI.removeMenu()
	end

	function GUI.drawStatusText()
		if(nextDrawTime == nil or prevText ~= GUI.statusText.text) then
			nextDrawTime = natives.GAMEPLAY.GET_GAME_TIMER() + GUI.statusText.time
		end

		if(nextDrawTime > natives.GAMEPLAY.GET_GAME_TIMER()) then
			prevText = GUI.statusText.text
			natives.UI.SET_TEXT_FONT(0)
			natives.UI.SET_TEXT_SCALE(0.55, 0.55)
			natives.UI.SET_TEXT_COLOUR(255, 255, 255, 255)
			natives.UI.SET_TEXT_WRAP(0.0, 1.0)
			natives.UI.SET_TEXT_CENTRE(true)
			natives.UI.SET_TEXT_DROPSHADOW(0, 0, 0, 0, 0)
			natives.UI.SET_TEXT_EDGE(1, 0, 0, 0, 205)
			natives.UI._SET_TEXT_ENTRY("STRING")
			natives.UI._ADD_TEXT_COMPONENT_STRING(GUI.statusText.text)
			natives.UI._DRAW_TEXT(0.5, 0.5)
		else
			GUI.statusText = {["text"] = "", ["time"] = 0}
			nextDrawTime = nil
		end
	end

	function GUI.drawGUI()
		if(GUI.activeMenu ~= "" and GUI.activeMenu ~= nil) then
			local name = GUI.activeMenu

			if(GUI.menu[name] ~= nil) then
				local xpos = GUI.menu[name].xpos
				local ypos = GUI.menu[name].ypos
				local xscale = GUI.menu[name].xscale
				local yscale = GUI.menu[name].yscale
				
				local text = GUI.menu[name].title
				local textScale = GUI.menu[name].textScale
				local font = GUI.menu[name].font
				local colors = {["r"] = 0, ["g"] = 0, ["b"] = 0, ["o"] = 255}

				addButtonText(text, xpos, ypos, textScale, font)
				natives.GRAPHICS.DRAW_RECT(xpos, ypos, xscale, yscale, colors.r, colors.g, colors.b, colors.o);

				if(GUI.buttons[name] ~= nil) then
					for i, v in pairs(GUI.buttons[name].settings) do
						local buttonSettings = GUI.buttons[name].settings[i]
						local xpos = buttonSettings.xpos
						local ypos = buttonSettings.ypos
						local xscale = buttonSettings.xscale
						local yscale = buttonSettings.yscale
						
						local font = buttonSettings.font
						local text = buttonSettings.text
						local textScale = buttonSettings.textScale
						local colors = {["r"] = 70, ["g"] = 95, ["b"] = 95, ["o"] = 255}

						if(buttonSettings.toggledOn == true) then
							text = buttonSettings.text .. " [ON]"
						elseif(buttonSettings.toggledOn == false) then
							text = buttonSettings.text .. " [OFF]"
						end
						
						if(i == GUI.activeButton) then
							colors = {["r"] = 200, ["g"] = 218, ["b"] = 218, ["o"] = 255}
						end

						addButtonText(text, xpos, ypos, textScale, font)
						natives.GRAPHICS.DRAW_RECT(xpos, ypos, xscale, yscale, colors.r, colors.g, colors.b, colors.o);
					end
				else
					print("No buttons associated with menu: ", GUI.activeMenu)
					GUI.setActiveMenu("")
				end
			else
				print("No menu created with the name: ", GUI.activeMenu)
				GUI.setActiveMenu("")
			end
		end
	end

	function addButtonText(text, xpos, ypos, textScale, font)
		if(text ~= nil and xpos ~= nil and ypos ~= nil and textScale ~= nil and font ~= nil) then
			natives.UI.SET_TEXT_FONT(font)
			natives.UI.SET_TEXT_SCALE(0.0, textScale)
			natives.UI.SET_TEXT_COLOUR(255, 255, 255, 255)
			natives.UI.SET_TEXT_CENTRE(true)
			natives.UI.SET_TEXT_DROPSHADOW(0, 0, 0, 0, 0)
			natives.UI.SET_TEXT_EDGE(0, 0, 0, 0, 0)
			natives.UI._SET_TEXT_ENTRY("STRING")
			natives.UI._ADD_TEXT_COMPONENT_STRING(text)
			natives.UI._DRAW_TEXT(xpos, ypos - 0.0125)
		else
			print("text: ", text, ", xpos: ", xpos, ", ypos: ", ypos, ", textScale: ", textScale, ", font: ", font)
		    print("There seems to be a nil value when trying to add text to button (see above)")
		    GUI.setActiveMenu("")
		end
	end

	function GUI.tick()
		GUI.drawStatusText()
		GUI.drawGUI()

		for i, key in pairs(GUI.navButtons.menuOpen.keys) do
			if(IsKeyDown(key)) then
				if(GUI.activeMenu == GUI.navButtons.menuOpen.menu) then
					GUI.setActiveMenu(GUI.menu[GUI.activeMenu].prevMenu)
				else
				    GUI.setActiveMenu(GUI.navButtons.menuOpen.menu)
				    GUI.currentSelection = 1
				end
			end
		end

		for k, key in pairs(GUI.navButtons.navUp.keys) do
			if(IsKeyDown(key) and GUI.activeMenu ~= "") then
				GUI.activeButton = GUI.activeButton - 1

				if(GUI.activeButton <= 0) then
					GUI.activeButton = GUI.menu[GUI.activeMenu].numButtons
				end
			end
		end

		for k, key in pairs(GUI.navButtons.navDown.keys) do
			if(IsKeyDown(key) and GUI.activeMenu ~= "") then
				GUI.activeButton = GUI.activeButton + 1
				
				if(GUI.activeButton > GUI.menu[GUI.activeMenu].numButtons) then
					GUI.activeButton = 1
				end
			end
		end

		for k, key in pairs(GUI.navButtons.select.keys) do
			if(IsKeyDown(key) and GUI.activeMenu ~= "") then
				local currButton = GUI.buttons[GUI.activeMenu].settings[GUI.activeButton]
				
				if(type(currButton.funct) == "function" and type(currButton.args) == "table") then
					GUI.toggleButtonState()
					currButton.funct(currButton.args[1], currButton.args[2], currButton.args[3], currButton.args[4], currButton.args[5], currButton.args[6], currButton.args[7], currButton.args[8], currButton.args[9], currButton.args[10], currButton.args[11], currButton.args[12], currButton.args[13], currButton.args[14], currButton.args[15], currButton.args[16], currButton.args[17], currButton.args[18], currButton.args[19], currButton.args[20])

				elseif(type(currButton.funct) == "function" and type(currButton.args) == "string" or type(currButton.args) == "number"or type(currButton.args) == "boolean") then
					GUI.toggleButtonState()
					currButton.funct(currButton.args)
					
				elseif(currButton.args == nil) then
					GUI.toggleButtonState()
					currButton.funct()

				else
					print("function: ", currButton.funct, ", args: ", currButton.args)
					print("Error: button \"", GUI.buttons[GUI.activeMenu].settings[GUI.activeButton].text, "\" doesn't seem to have a function or the arguments are invalid. Are you calling it correctly?" )
				end
			end
		end

		for k, key in pairs(GUI.navButtons.navBack.keys) do
			if(IsKeyDown(key) and GUI.activeMenu ~= "") then
				GUI.setActiveMenu(GUI.menu[GUI.activeMenu].prevMenu)
			end
		end
	end

	return GUI
end

--########################################################################
--functions for the buttons when pressed
function firstToUpper(str)
	return (str:gsub("^%l", string.upper))
end
function getRGB(given)
		if(given=="random")then
			randomColor = {math.random(0,255), math.random(0,255), math.random(0,255)}
			return randomColor
		else
			return color[given]
		end
end
function paint(color)
	rgb = getRGB(color)
	r = rgb[1]
	g = rgb[2]
	b = rgb[3]
--TODO
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE.SET_VEHICLE_CUSTOM_PRIMARY_COLOUR(veh, r, g, b)
		natives.VEHICLE.SET_VEHICLE_CUSTOM_SECONDARY_COLOUR(veh, r, g, b)
		GUI.updateStatusText("Color changed to " .. firstToUpper(color) .. "!", 1500)

	end
end
function paintPrimary(color)

	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		rgb = getRGB(color)
		r = rgb[1]
		g = rgb[2]
		b = rgb[3]
		natives.VEHICLE.SET_VEHICLE_CUSTOM_PRIMARY_COLOUR(veh, r, g, b)
		GUI.updateStatusText("Primary Color " .. firstToUpper(color) .. "!", 1500)
	end
			
		

	
end

function paintSecondary(color)

	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		rgb = getRGB(color)
		r = rgb[1]
		g = rgb[2]
		b = rgb[3]
		natives.VEHICLE.SET_VEHICLE_CUSTOM_SECONDARY_COLOUR(veh, r, g, b)
		GUI.updateStatusText("Secondary color " .. firstToUpper(color) .. "!", 1500)
	end
			
		

end

function customizeE()
				if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
				local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)	
				natives.VEHICLE.SET_VEHICLE_MOD_KIT(veh, 0)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 11, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 11)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 12, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 12)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 13, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 13)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 15, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 15)-1, true)
				natives.VEHICLE.TOGGLE_VEHICLE_MOD(veh, 18, true)
				GUI.updateStatusText("Engine Upgraded to the max!", 1500)
				
end
end

function customizeC()
				if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
				local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)	
				natives.VEHICLE.SET_VEHICLE_MOD_KIT(veh, 0)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 1, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 1)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 2, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 2)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 3, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 3)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 5, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 5)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 6, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 6)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 7, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 7)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 8, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 8)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 9, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 9)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 10, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 10)-1, true)
				natives.VEHICLE.TOGGLE_VEHICLE_MOD(veh, 22, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 23, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 23)-1, true)
				if(natives.VEHICLE.IS_THIS_MODEL_A_BIKE)then
					natives.VEHICLE.SET_VEHICLE_MOD(veh, 24, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 24)-1, true)
				end
				natives.VEHICLE.SET_VEHICLE_FIXED(veh)
				GUI.updateStatusText("Cosmetics Upgraded to the max!", 1500)
end
end

function customizeP()
				if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
				local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)	
				natives.VEHICLE.SET_VEHICLE_MOD_KIT(veh, 0)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 0, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 0)-1, true)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 4, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 4)-1, true)
				GUI.updateStatusText("Maxed out performance parts added!", 1500)
end
end

function customizeS()
				if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
				local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)	
				natives.VEHICLE.SET_VEHICLE_MOD_KIT(veh, 0)
				natives.VEHICLE.SET_VEHICLE_MOD(veh, 16, natives.VEHICLE.GET_NUM_VEHICLE_MODS(veh, 0)-1, true)
				natives.VEHICLE.SET_VEHICLE_TYRES_CAN_BURST(veh, false)
				GUI.updateStatusText("Armor and unburstable tyres added!", 1500)
end
end

function customizeA()
	customizeE()
	customizeP()
	customizeC()
	GUI.updateStatusText("Everything Upgraded but safety features!", 1500)
	
end
function fixVeh()
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE.SET_VEHICLE_FIXED(veh)
		GUI.updateStatusText("Vehicle Fixed!", 1500)
	end

end

function changeNeonColor(color)
	rgb = getRGB(color)
	r = rgb[1]
	g = rgb[2]
	b = rgb[3]
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE._0x8E0A582209A62695(veh, r,  g, b)
		for i=0,3,1 do natives.VEHICLE._0x2AA720E4287BF269(veh, i, true) end
	end
	
end

function resetA()
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 0)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 1)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 2)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 3)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 4)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 5)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 6)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 7)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 8)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 9)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 10)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 11)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 12)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 13)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 14)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 15)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 16)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 17)
		natives.VEHICLE.TOGGLE_VEHICLE_MOD(veh, 18, false)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 19)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 20)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 21)
		natives.VEHICLE.TOGGLE_VEHICLE_MOD(veh, 22, false)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 23)
		natives.VEHICLE.REMOVE_VEHICLE_MOD(veh, 24)
		natives.VEHICLE.SET_VEHICLE_TYRES_CAN_BURST(veh, true)
	end
end
function cleanVeh()
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE.SET_VEHICLE_DIRT_LEVEL(veh, 0)
		GUI.updateStatusText("Vehicle Cleaned!", 1500)
	end
end
function setPaintType(type)
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE.SET_VEHICLE_MOD_COLOR_1(veh, type, 0, 0)
		natives.VEHICLE.SET_VEHICLE_MOD_COLOR_2(veh, type, 0, 0)
	end
end
function setPaintTypeP(type)
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE.SET_VEHICLE_MOD_COLOR_1(veh, type, 0, 0)
	end
end
function setPaintTypeS(type)
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		natives.VEHICLE.SET_VEHICLE_MOD_COLOR_2(veh, type, 0, 0)
	end
end
function neonOff()
	if(natives.PED.IS_PED_IN_ANY_VEHICLE(natives.PLAYER.GET_PLAYER_PED(-1), false))then
		local veh = natives.PED.GET_VEHICLE_PED_IS_IN(natives.PLAYER.GET_PLAYER_PED(-1), true)
		for i=0,3,1 do natives.VEHICLE._0x2AA720E4287BF269(veh, i, false) end
	end
end
--#########################################################################

function mainInit()
	GUI = GUIinit()


	GUI.createMenu("main", "", "Customisations", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
	GUI.addButton("main", "Customisation", GUI.setActiveMenu, "customs", false, 0.35, 0)
	GUI.addButton("main", "Color Menu", GUI.setActiveMenu, "paint", false, 0.35, 0)
	GUI.addButton("main", "Fix Vehicle", fixVeh, "", false, 0.35, 0)
	GUI.addButton("main", "Clean Vehicle", cleanVeh, "", false, 0.35, 0)

	GUI.createMenu("customs", "main", "Customisations", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
	GUI.addButton("customs", "All but Safety", customizeA, "", false, 0.35, 0)
	GUI.addButton("customs", "Remove All", resetA, "", false, 0.35, 0)
	GUI.addButton("customs", "Safety", customizeS, "", false, 0.35, 0)
	GUI.addButton("customs", "Engine", customizeE, "", false, 0.35, 0)
	GUI.addButton("customs", "Performance Parts", customizeP, "", false, 0.35, 0)
	GUI.addButton("customs", "Cosmetic", customizeC, "", false, 0.35, 0)
	
	GUI.createMenu("paint", "main", "Color Menu", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
	GUI.addButton("paint", "both colors", GUI.setActiveMenu, "cols", false, 0.35, 0)
	GUI.addButton("paint", "primary color", GUI.setActiveMenu, "pricol", false, 0.35, 0)
	GUI.addButton("paint", "secondary color", GUI.setActiveMenu, "secol", false, 0.35, 0)
	GUI.addButton("paint", "paint type (beta)", GUI.setActiveMenu, "ptypemain", false, 0.35, 0)
	GUI.addButton("paint", "neon (beta)", GUI.setActiveMenu, "neon", false, 0.35, 0)

	
	GUI.createMenu("ptypemain", "paint", "Paint Type", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
	GUI.addButton("ptypemain", "both", GUI.setActiveMenu, "ptype", false, 0.35, 0)
	GUI.addButton("ptypemain", "primary", GUI.setActiveMenu, "ptypep", false, 0.35, 0)
	GUI.addButton("ptypemain", "secondary", GUI.setActiveMenu, "ptypes", false, 0.35, 0)

	GUI.createMenu("ptype", "ptypemain", "Overall Type", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
	GUI.addButton("ptype", "Normal", setPaintType, 0, false, 0.35, 0)
	GUI.addButton("ptype", "Metallic", setPaintType, 1, false, 0.35, 0)
	GUI.addButton("ptype", "Matte", setPaintType, 3, false, 0.35, 0)
	GUI.addButton("ptype", "Metal", setPaintType, 4, false, 0.35, 0)
	GUI.addButton("ptype", "Chrome", setPaintType, 5, false, 0.35, 0)

	GUI.createMenu("ptypep", "ptypemain", "Primary Type", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
	GUI.addButton("ptypep", "Normal", setPaintTypeP, 0, false, 0.35, 0)
	GUI.addButton("ptypep", "Metallic", setPaintTypeP, 1, false, 0.35, 0)
	GUI.addButton("ptypep", "Matte", setPaintTypeP, 3, false, 0.35, 0)
	GUI.addButton("ptypep", "Metal", setPaintTypeP, 4, false, 0.35, 0)
	GUI.addButton("ptypep", "Chrome", setPaintTypeP, 5, false, 0.35, 0)

	GUI.createMenu("ptypes", "ptypemain", "Secondary Type", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
	GUI.addButton("ptypes", "Normal", setPaintTypeS, 0, false, 0.35, 0)
	GUI.addButton("ptypes", "Metallic", setPaintTypeS, 1, false, 0.35, 0)
	GUI.addButton("ptypes", "Matte", setPaintTypeS, 3, false, 0.35, 0)
	GUI.addButton("ptypes", "Metal", setPaintTypeS, 4, false, 0.35, 0)
	GUI.addButton("ptypes", "Chrome", setPaintTypeS, 5, false, 0.35, 0)

	GUI.createMenu("cols", "paint", "Overall Color", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
		for key,value in pairs(color) do
   			GUI.addButton("cols", firstToUpper(key), paint, key, false, 0.35, 0)
		end
	
	
	GUI.createMenu("neon", "paint", "Neon Color", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
		GUI.addButton("neon", "Turn OFF", neonOff, "", false, 0.35, 0)
		for key,value in pairs(color) do
   			GUI.addButton("neon", firstToUpper(key), changeNeonColor, key, false, 0.35, 0)
		end
	
	GUI.createMenu("pricol", "paint", "Primary Color", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
		for key,value in pairs(color) do
   			GUI.addButton("pricol", firstToUpper(key), paintPrimary, key, false, 0.35, 0)
		end

		GUI.createMenu("secol", "paint", "Secondary Color", 0.09, 0.1, 0.125, 0.0625, 0.001, .35, 1)
		for key,value in pairs(color) do
   			GUI.addButton("secol", firstToUpper(key), paintSecondary, key, false, 0.35, 0)
		end
end

-- Run function
-- This is called once! It's your job to keep this alive!
function main:Run()
	-- ran once
	mainInit()

	--list of key codes https://msdn.microsoft.com/en-us/library/windows/desktop/dd375731%28v=vs.85%29.aspx
	local f5 = openkey
	local numpad2 = downKey
	local numpad8 = upKey
	local numpad5 = selectKey
	local numpad9 = openkey
	local numpad0 = backKey

	GUI.navButtons = {
						
						["menuOpen"] = 
						{
							["keys"] = {f5},
							["menu"] = "main"
						},
						["navUp"] 	 = {["keys"] = {numpad8}}, 
						["navDown"]  = {["keys"] = {numpad2}}, 
						["select"] 	 = {["keys"] = {numpad5}}, 
						["navBack"]  = {["keys"] = {numpad0}}
					}

	while self:IsRunning() do
		GUI.tick()

		self:Wait(0)
	end
end
function main:OnError() end
main:Register()